# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class FstatCommand(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        FstatCommand - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'depot_file': 'str',
            'moved_file': 'str',
            'shelved': 'str',
            'head_action': 'str',
            'head_change': 'str',
            'head_rev': 'str',
            'head_type': 'str',
            'head_charset': 'str',
            'head_time': 'datetime',
            'head_mod_time': 'datetime',
            'moved_rev': 'str',
            'digest': 'str',
            'file_size': 'str',
            'action_owner': 'str',
            'resolved': 'str',
            'unresolved': 'str',
            'reresolvable': 'str',
            'other_opens': 'list[str]',
            'other_locks': 'list[str]',
            'other_actions': 'list[str]',
            'other_changes': 'list[str]',
            'resolve_actions': 'list[str]',
            'resolve_base_files': 'list[str]',
            'resolve_base_revs': 'list[str]',
            'resolve_from_files': 'list[str]',
            'resolve_start_from_revs': 'list[str]',
            'resolve_end_from_revs': 'list[str]'
        }

        self.attribute_map = {
            'depot_file': 'depotFile',
            'moved_file': 'movedFile',
            'shelved': 'shelved',
            'head_action': 'headAction',
            'head_change': 'headChange',
            'head_rev': 'headRev',
            'head_type': 'headType',
            'head_charset': 'headCharset',
            'head_time': 'headTime',
            'head_mod_time': 'headModTime',
            'moved_rev': 'movedRev',
            'digest': 'digest',
            'file_size': 'fileSize',
            'action_owner': 'actionOwner',
            'resolved': 'resolved',
            'unresolved': 'unresolved',
            'reresolvable': 'reresolvable',
            'other_opens': 'otherOpens',
            'other_locks': 'otherLocks',
            'other_actions': 'otherActions',
            'other_changes': 'otherChanges',
            'resolve_actions': 'resolveActions',
            'resolve_base_files': 'resolveBaseFiles',
            'resolve_base_revs': 'resolveBaseRevs',
            'resolve_from_files': 'resolveFromFiles',
            'resolve_start_from_revs': 'resolveStartFromRevs',
            'resolve_end_from_revs': 'resolveEndFromRevs'
        }

        self._depot_file = None
        self._moved_file = None
        self._shelved = None
        self._head_action = None
        self._head_change = None
        self._head_rev = None
        self._head_type = None
        self._head_charset = None
        self._head_time = None
        self._head_mod_time = None
        self._moved_rev = None
        self._digest = None
        self._file_size = None
        self._action_owner = None
        self._resolved = None
        self._unresolved = None
        self._reresolvable = None
        self._other_opens = None
        self._other_locks = None
        self._other_actions = None
        self._other_changes = None
        self._resolve_actions = None
        self._resolve_base_files = None
        self._resolve_base_revs = None
        self._resolve_from_files = None
        self._resolve_start_from_revs = None
        self._resolve_end_from_revs = None

    @property
    def depot_file(self):
        """
        Gets the depot_file of this FstatCommand.
        Depot path to file.\nFor files containing special characters, the filename is displayed containing the ASCII expression of the character’s hexadecimal value.

        :return: The depot_file of this FstatCommand.
        :rtype: str
        """
        return self._depot_file

    @depot_file.setter
    def depot_file(self, depot_file):
        """
        Sets the depot_file of this FstatCommand.
        Depot path to file.\nFor files containing special characters, the filename is displayed containing the ASCII expression of the character’s hexadecimal value.

        :param depot_file: The depot_file of this FstatCommand.
        :type: str
        """
        self._depot_file = depot_file

    @property
    def moved_file(self):
        """
        Gets the moved_file of this FstatCommand.
        Name in depot of moved to/from file.

        :return: The moved_file of this FstatCommand.
        :rtype: str
        """
        return self._moved_file

    @moved_file.setter
    def moved_file(self, moved_file):
        """
        Sets the moved_file of this FstatCommand.
        Name in depot of moved to/from file.

        :param moved_file: The moved_file of this FstatCommand.
        :type: str
        """
        self._moved_file = moved_file

    @property
    def shelved(self):
        """
        Gets the shelved of this FstatCommand.
        Set to `shelved` if file is shelved.

        :return: The shelved of this FstatCommand.
        :rtype: str
        """
        return self._shelved

    @shelved.setter
    def shelved(self, shelved):
        """
        Sets the shelved of this FstatCommand.
        Set to `shelved` if file is shelved.

        :param shelved: The shelved of this FstatCommand.
        :type: str
        """
        self._shelved = shelved

    @property
    def head_action(self):
        """
        Gets the head_action of this FstatCommand.
        Action taken at head revision, if in depot.\n\nOne of: add, edit, delete, branch, move/add, move/delete, integrate, import, purge, or archive.

        :return: The head_action of this FstatCommand.
        :rtype: str
        """
        return self._head_action

    @head_action.setter
    def head_action(self, head_action):
        """
        Sets the head_action of this FstatCommand.
        Action taken at head revision, if in depot.\n\nOne of: add, edit, delete, branch, move/add, move/delete, integrate, import, purge, or archive.

        :param head_action: The head_action of this FstatCommand.
        :type: str
        """
        self._head_action = head_action

    @property
    def head_change(self):
        """
        Gets the head_change of this FstatCommand.
        Head revision changelist number, if in depot.

        :return: The head_change of this FstatCommand.
        :rtype: str
        """
        return self._head_change

    @head_change.setter
    def head_change(self, head_change):
        """
        Sets the head_change of this FstatCommand.
        Head revision changelist number, if in depot.

        :param head_change: The head_change of this FstatCommand.
        :type: str
        """
        self._head_change = head_change

    @property
    def head_rev(self):
        """
        Gets the head_rev of this FstatCommand.
        Head revision number, if in depot.

        :return: The head_rev of this FstatCommand.
        :rtype: str
        """
        return self._head_rev

    @head_rev.setter
    def head_rev(self, head_rev):
        """
        Sets the head_rev of this FstatCommand.
        Head revision number, if in depot.

        :param head_rev: The head_rev of this FstatCommand.
        :type: str
        """
        self._head_rev = head_rev

    @property
    def head_type(self):
        """
        Gets the head_type of this FstatCommand.
        Head revision type, if in depot.

        :return: The head_type of this FstatCommand.
        :rtype: str
        """
        return self._head_type

    @head_type.setter
    def head_type(self, head_type):
        """
        Sets the head_type of this FstatCommand.
        Head revision type, if in depot.

        :param head_type: The head_type of this FstatCommand.
        :type: str
        """
        self._head_type = head_type

    @property
    def head_charset(self):
        """
        Gets the head_charset of this FstatCommand.
        Head charset, for unicode files.

        :return: The head_charset of this FstatCommand.
        :rtype: str
        """
        return self._head_charset

    @head_charset.setter
    def head_charset(self, head_charset):
        """
        Sets the head_charset of this FstatCommand.
        Head charset, for unicode files.

        :param head_charset: The head_charset of this FstatCommand.
        :type: str
        """
        self._head_charset = head_charset

    @property
    def head_time(self):
        """
        Gets the head_time of this FstatCommand.
        Head revision changelist time, if in depot.\nTime is measured in seconds since 00:00:00 UTC, January 1, 1970.

        :return: The head_time of this FstatCommand.
        :rtype: datetime
        """
        return self._head_time

    @head_time.setter
    def head_time(self, head_time):
        """
        Sets the head_time of this FstatCommand.
        Head revision changelist time, if in depot.\nTime is measured in seconds since 00:00:00 UTC, January 1, 1970.

        :param head_time: The head_time of this FstatCommand.
        :type: datetime
        """
        self._head_time = head_time

    @property
    def head_mod_time(self):
        """
        Gets the head_mod_time of this FstatCommand.
        Head revision modification time (the time that the file was last modified on the client before submit), if in depot.

        :return: The head_mod_time of this FstatCommand.
        :rtype: datetime
        """
        return self._head_mod_time

    @head_mod_time.setter
    def head_mod_time(self, head_mod_time):
        """
        Sets the head_mod_time of this FstatCommand.
        Head revision modification time (the time that the file was last modified on the client before submit), if in depot.

        :param head_mod_time: The head_mod_time of this FstatCommand.
        :type: datetime
        """
        self._head_mod_time = head_mod_time

    @property
    def moved_rev(self):
        """
        Gets the moved_rev of this FstatCommand.
        Head revision of moved file.

        :return: The moved_rev of this FstatCommand.
        :rtype: str
        """
        return self._moved_rev

    @moved_rev.setter
    def moved_rev(self, moved_rev):
        """
        Sets the moved_rev of this FstatCommand.
        Head revision of moved file.

        :param moved_rev: The moved_rev of this FstatCommand.
        :type: str
        """
        self._moved_rev = moved_rev

    @property
    def digest(self):
        """
        Gets the digest of this FstatCommand.
        MD5 digest of a file.

        :return: The digest of this FstatCommand.
        :rtype: str
        """
        return self._digest

    @digest.setter
    def digest(self, digest):
        """
        Sets the digest of this FstatCommand.
        MD5 digest of a file.

        :param digest: The digest of this FstatCommand.
        :type: str
        """
        self._digest = digest

    @property
    def file_size(self):
        """
        Gets the file_size of this FstatCommand.
        File length in bytes.

        :return: The file_size of this FstatCommand.
        :rtype: str
        """
        return self._file_size

    @file_size.setter
    def file_size(self, file_size):
        """
        Sets the file_size of this FstatCommand.
        File length in bytes.

        :param file_size: The file_size of this FstatCommand.
        :type: str
        """
        self._file_size = file_size

    @property
    def action_owner(self):
        """
        Gets the action_owner of this FstatCommand.
        User who opened the file, if open.

        :return: The action_owner of this FstatCommand.
        :rtype: str
        """
        return self._action_owner

    @action_owner.setter
    def action_owner(self, action_owner):
        """
        Sets the action_owner of this FstatCommand.
        User who opened the file, if open.

        :param action_owner: The action_owner of this FstatCommand.
        :type: str
        """
        self._action_owner = action_owner

    @property
    def resolved(self):
        """
        Gets the resolved of this FstatCommand.
        The number, if any, of resovled integration records.

        :return: The resolved of this FstatCommand.
        :rtype: str
        """
        return self._resolved

    @resolved.setter
    def resolved(self, resolved):
        """
        Sets the resolved of this FstatCommand.
        The number, if any, of resovled integration records.

        :param resolved: The resolved of this FstatCommand.
        :type: str
        """
        self._resolved = resolved

    @property
    def unresolved(self):
        """
        Gets the unresolved of this FstatCommand.
        The number, if any, of unresolved integration records.

        :return: The unresolved of this FstatCommand.
        :rtype: str
        """
        return self._unresolved

    @unresolved.setter
    def unresolved(self, unresolved):
        """
        Sets the unresolved of this FstatCommand.
        The number, if any, of unresolved integration records.

        :param unresolved: The unresolved of this FstatCommand.
        :type: str
        """
        self._unresolved = unresolved

    @property
    def reresolvable(self):
        """
        Gets the reresolvable of this FstatCommand.
        The number, if any, of re-resolvable integration records.

        :return: The reresolvable of this FstatCommand.
        :rtype: str
        """
        return self._reresolvable

    @reresolvable.setter
    def reresolvable(self, reresolvable):
        """
        Sets the reresolvable of this FstatCommand.
        The number, if any, of re-resolvable integration records.

        :param reresolvable: The reresolvable of this FstatCommand.
        :type: str
        """
        self._reresolvable = reresolvable

    @property
    def other_opens(self):
        """
        Gets the other_opens of this FstatCommand.
        For each user with the file open, the workspace and user with the open file.

        :return: The other_opens of this FstatCommand.
        :rtype: list[str]
        """
        return self._other_opens

    @other_opens.setter
    def other_opens(self, other_opens):
        """
        Sets the other_opens of this FstatCommand.
        For each user with the file open, the workspace and user with the open file.

        :param other_opens: The other_opens of this FstatCommand.
        :type: list[str]
        """
        self._other_opens = other_opens

    @property
    def other_locks(self):
        """
        Gets the other_locks of this FstatCommand.
        For each user with the file locked, the workspace and user holding the lock.

        :return: The other_locks of this FstatCommand.
        :rtype: list[str]
        """
        return self._other_locks

    @other_locks.setter
    def other_locks(self, other_locks):
        """
        Sets the other_locks of this FstatCommand.
        For each user with the file locked, the workspace and user holding the lock.

        :param other_locks: The other_locks of this FstatCommand.
        :type: list[str]
        """
        self._other_locks = other_locks

    @property
    def other_actions(self):
        """
        Gets the other_actions of this FstatCommand.
        For each user with the file open, the action taken.

        :return: The other_actions of this FstatCommand.
        :rtype: list[str]
        """
        return self._other_actions

    @other_actions.setter
    def other_actions(self, other_actions):
        """
        Sets the other_actions of this FstatCommand.
        For each user with the file open, the action taken.

        :param other_actions: The other_actions of this FstatCommand.
        :type: list[str]
        """
        self._other_actions = other_actions

    @property
    def other_changes(self):
        """
        Gets the other_changes of this FstatCommand.
        The changelist number with this file open.

        :return: The other_changes of this FstatCommand.
        :rtype: list[str]
        """
        return self._other_changes

    @other_changes.setter
    def other_changes(self, other_changes):
        """
        Sets the other_changes of this FstatCommand.
        The changelist number with this file open.

        :param other_changes: The other_changes of this FstatCommand.
        :type: list[str]
        """
        self._other_changes = other_changes

    @property
    def resolve_actions(self):
        """
        Gets the resolve_actions of this FstatCommand.
        Pending integration action.

        :return: The resolve_actions of this FstatCommand.
        :rtype: list[str]
        """
        return self._resolve_actions

    @resolve_actions.setter
    def resolve_actions(self, resolve_actions):
        """
        Sets the resolve_actions of this FstatCommand.
        Pending integration action.

        :param resolve_actions: The resolve_actions of this FstatCommand.
        :type: list[str]
        """
        self._resolve_actions = resolve_actions

    @property
    def resolve_base_files(self):
        """
        Gets the resolve_base_files of this FstatCommand.
        Pending base files.

        :return: The resolve_base_files of this FstatCommand.
        :rtype: list[str]
        """
        return self._resolve_base_files

    @resolve_base_files.setter
    def resolve_base_files(self, resolve_base_files):
        """
        Sets the resolve_base_files of this FstatCommand.
        Pending base files.

        :param resolve_base_files: The resolve_base_files of this FstatCommand.
        :type: list[str]
        """
        self._resolve_base_files = resolve_base_files

    @property
    def resolve_base_revs(self):
        """
        Gets the resolve_base_revs of this FstatCommand.
        Pending base revision numbers.

        :return: The resolve_base_revs of this FstatCommand.
        :rtype: list[str]
        """
        return self._resolve_base_revs

    @resolve_base_revs.setter
    def resolve_base_revs(self, resolve_base_revs):
        """
        Sets the resolve_base_revs of this FstatCommand.
        Pending base revision numbers.

        :param resolve_base_revs: The resolve_base_revs of this FstatCommand.
        :type: list[str]
        """
        self._resolve_base_revs = resolve_base_revs

    @property
    def resolve_from_files(self):
        """
        Gets the resolve_from_files of this FstatCommand.
        Pending from files.

        :return: The resolve_from_files of this FstatCommand.
        :rtype: list[str]
        """
        return self._resolve_from_files

    @resolve_from_files.setter
    def resolve_from_files(self, resolve_from_files):
        """
        Sets the resolve_from_files of this FstatCommand.
        Pending from files.

        :param resolve_from_files: The resolve_from_files of this FstatCommand.
        :type: list[str]
        """
        self._resolve_from_files = resolve_from_files

    @property
    def resolve_start_from_revs(self):
        """
        Gets the resolve_start_from_revs of this FstatCommand.
        Pending starting revisions.

        :return: The resolve_start_from_revs of this FstatCommand.
        :rtype: list[str]
        """
        return self._resolve_start_from_revs

    @resolve_start_from_revs.setter
    def resolve_start_from_revs(self, resolve_start_from_revs):
        """
        Sets the resolve_start_from_revs of this FstatCommand.
        Pending starting revisions.

        :param resolve_start_from_revs: The resolve_start_from_revs of this FstatCommand.
        :type: list[str]
        """
        self._resolve_start_from_revs = resolve_start_from_revs

    @property
    def resolve_end_from_revs(self):
        """
        Gets the resolve_end_from_revs of this FstatCommand.
        Pending ending revisions.

        :return: The resolve_end_from_revs of this FstatCommand.
        :rtype: list[str]
        """
        return self._resolve_end_from_revs

    @resolve_end_from_revs.setter
    def resolve_end_from_revs(self, resolve_end_from_revs):
        """
        Sets the resolve_end_from_revs of this FstatCommand.
        Pending ending revisions.

        :param resolve_end_from_revs: The resolve_end_from_revs of this FstatCommand.
        :type: list[str]
        """
        self._resolve_end_from_revs = resolve_end_from_revs

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

