# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class UserCommand(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        UserCommand - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'user': 'str',
            'type': 'str',
            'auth_method': 'str',
            'email': 'str',
            'update': 'datetime',
            'access': 'datetime',
            'full_name': 'str',
            'job_view': 'str',
            'password': 'str',
            'password_change': 'datetime',
            'reviews': 'list[str]'
        }

        self.attribute_map = {
            'user': 'user',
            'type': 'type',
            'auth_method': 'authMethod',
            'email': 'email',
            'update': 'update',
            'access': 'access',
            'full_name': 'fullName',
            'job_view': 'jobView',
            'password': 'password',
            'password_change': 'passwordChange',
            'reviews': 'reviews'
        }

        self._user = None
        self._type = None
        self._auth_method = None
        self._email = None
        self._update = None
        self._access = None
        self._full_name = None
        self._job_view = None
        self._password = None
        self._password_change = None
        self._reviews = None

    @property
    def user(self):
        """
        Gets the user of this UserCommand.
        The Perforce username.

        :return: The user of this UserCommand.
        :rtype: str
        """
        return self._user

    @user.setter
    def user(self, user):
        """
        Sets the user of this UserCommand.
        The Perforce username.

        :param user: The user of this UserCommand.
        :type: str
        """
        self._user = user

    @property
    def type(self):
        """
        Gets the type of this UserCommand.
        Type of user: standard, operator, or service.\n\nOnce you set the type, you cannot change it.

        :return: The type of this UserCommand.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this UserCommand.
        Type of user: standard, operator, or service.\n\nOnce you set the type, you cannot change it.

        :param type: The type of this UserCommand.
        :type: str
        """
        self._type = type

    @property
    def auth_method(self):
        """
        Gets the auth_method of this UserCommand.
        One of the following: perforce or ldap.\n\nSpecifying perforce enables authentication using Perforce’s internal db.user table or by way of an authentication trigger.\nThis is the default unless it is overridden with the auth.default.method configurable.\n\nSpecifying ldap enables authentication against AD/LDAP servers specified by the currently active LDAP configurations.

        :return: The auth_method of this UserCommand.
        :rtype: str
        """
        return self._auth_method

    @auth_method.setter
    def auth_method(self, auth_method):
        """
        Sets the auth_method of this UserCommand.
        One of the following: perforce or ldap.\n\nSpecifying perforce enables authentication using Perforce’s internal db.user table or by way of an authentication trigger.\nThis is the default unless it is overridden with the auth.default.method configurable.\n\nSpecifying ldap enables authentication against AD/LDAP servers specified by the currently active LDAP configurations.

        :param auth_method: The auth_method of this UserCommand.
        :type: str
        """
        self._auth_method = auth_method

    @property
    def email(self):
        """
        Gets the email of this UserCommand.
        The user’s email address. By default, this is user@client.

        :return: The email of this UserCommand.
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """
        Sets the email of this UserCommand.
        The user’s email address. By default, this is user@client.

        :param email: The email of this UserCommand.
        :type: str
        """
        self._email = email

    @property
    def update(self):
        """
        Gets the update of this UserCommand.
        The date and time this specification was last updated.

        :return: The update of this UserCommand.
        :rtype: datetime
        """
        return self._update

    @update.setter
    def update(self, update):
        """
        Sets the update of this UserCommand.
        The date and time this specification was last updated.

        :param update: The update of this UserCommand.
        :type: datetime
        """
        self._update = update

    @property
    def access(self):
        """
        Gets the access of this UserCommand.
        The date and time this user last ran a Perforce command.

        :return: The access of this UserCommand.
        :rtype: datetime
        """
        return self._access

    @access.setter
    def access(self, access):
        """
        Sets the access of this UserCommand.
        The date and time this user last ran a Perforce command.

        :param access: The access of this UserCommand.
        :type: datetime
        """
        self._access = access

    @property
    def full_name(self):
        """
        Gets the full_name of this UserCommand.
        The user's full name.

        :return: The full_name of this UserCommand.
        :rtype: str
        """
        return self._full_name

    @full_name.setter
    def full_name(self, full_name):
        """
        Sets the full_name of this UserCommand.
        The user's full name.

        :param full_name: The full_name of this UserCommand.
        :type: str
        """
        self._full_name = full_name

    @property
    def job_view(self):
        """
        Gets the job_view of this UserCommand.
        Jobs matching this jobview appear on any changelists created by this user.\nJobs that are fixed by the changelist should be left in the changelist when it's submitted with p4 submit; other jobs should be deleted from the form before submission.

        :return: The job_view of this UserCommand.
        :rtype: str
        """
        return self._job_view

    @job_view.setter
    def job_view(self, job_view):
        """
        Sets the job_view of this UserCommand.
        Jobs matching this jobview appear on any changelists created by this user.\nJobs that are fixed by the changelist should be left in the changelist when it's submitted with p4 submit; other jobs should be deleted from the form before submission.

        :param job_view: The job_view of this UserCommand.
        :type: str
        """
        self._job_view = job_view

    @property
    def password(self):
        """
        Gets the password of this UserCommand.
        The user's password.

        :return: The password of this UserCommand.
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password):
        """
        Sets the password of this UserCommand.
        The user's password.

        :param password: The password of this UserCommand.
        :type: str
        """
        self._password = password

    @property
    def password_change(self):
        """
        Gets the password_change of this UserCommand.
        The date and time of the user’s last password change.\nIf the user has no password, this field is blank.

        :return: The password_change of this UserCommand.
        :rtype: datetime
        """
        return self._password_change

    @password_change.setter
    def password_change(self, password_change):
        """
        Sets the password_change of this UserCommand.
        The date and time of the user’s last password change.\nIf the user has no password, this field is blank.

        :param password_change: The password_change of this UserCommand.
        :type: datetime
        """
        self._password_change = password_change

    @property
    def reviews(self):
        """
        Gets the reviews of this UserCommand.
        A list of files the user would like to review.\nThis field can include exclusionary mappings.

        :return: The reviews of this UserCommand.
        :rtype: list[str]
        """
        return self._reviews

    @reviews.setter
    def reviews(self, reviews):
        """
        Sets the reviews of this UserCommand.
        A list of files the user would like to review.\nThis field can include exclusionary mappings.

        :param reviews: The reviews of this UserCommand.
        :type: list[str]
        """
        self._reviews = reviews

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

